﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace MurrTest02
{
    public class Program
    {
        private static void Main(string[] args)
        {
            var test = new TClientHostProvider();
            List<TClientHost> hosts = TClientHostProvider.Clients.OrderBy(x => x.Client.Id).ToList();
            foreach (TClientHost clientHost in hosts)
            {
                Console.WriteLine("{0}.{1}",clientHost.Id,clientHost.Name);
            }

            Console.ReadKey();
        }
    }

    internal class TClientHostProvider
    {
        public static readonly List<TClientHost> Clients = new List<TClientHost>();

        public TClientHostProvider()
        {
            ClientTest01 clientTest01 = new ClientTest01();
            clientTest01.Client = clientTest01;
            ClientTest02 clientTest02 = new ClientTest02();
            clientTest02.Client = clientTest02;
            ClientTest03 clientTest03 = new ClientTest03();
            clientTest03.Client = clientTest03;
            Clients.Add(clientTest01);
            Clients.Add(clientTest03);
            Clients.Add(clientTest02);
            Clients.Add(clientTest01);
        }
    }

    internal interface IClient
    {
        int Id { get;  }
    }

    internal abstract class TClientHost : IClient
    {
        public abstract int Id { get;  }
        public abstract string Name { get; }

        public TClientHost Client { get; set; }
    }

    internal class ClientTest01:TClientHost
    {
        public override int Id => 1;

        public override string Name => "Test01";
    }

    internal class ClientTest02 : TClientHost
    {
        public override int Id => 2;

        public override string Name => "Test02";
    }
    internal class ClientTest03 : TClientHost
    {
        public override int Id => 3;

        public override string Name => "Test03";
    }
}